AbstractBean (install4j API)
Description: declaration: package: com.install4j.api.beans, class: AbstractBean

Package com.install4j.api.beans

# Class AbstractBean

java.lang.Object
com.install4j.api.beans.AbstractBean

All Implemented Interfaces:
  `Bean`

Direct Known Subclasses:
  `AbstractFormComponent`, `AbstractInstallAction`, `AbstractInstallerOrUninstallerScreen`, `AbstractInstallerScreen`, `AbstractInstallOrUninstallAction`, `AbstractStyle`, `AbstractUninstallAction`, `AbstractUninstallerScreen`

public abstract class AbstractBean extends Object implements Bean
Common base class for all abstract superclasses for beans that are handled by install4j. It is not recommended to extend this class directly. Concrete superclasses exist for

- screens
- actions
- form components

This class provides common utility methods for all bean types.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractBean()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `executeActionListAsync(ActionList actionList, Object... extraScriptParameters)`
  Asynchronously execute an action list.
  `static boolean`
  `executeActionListSync(ActionList actionList, Object... extraScriptParameters)`
  Synchronously execute an action list.
  `static <T> T`
  `getTextOverrideValue(Bean bean, String propertyName, Class<T> resultType)`
  Get the value for a property for which a text replacement has been configured in the IDE.
  `static File`
  `replaceVariables(File file)`
  Replace all installer variables and localization keys in a file name.
  `static File[]`
  `replaceVariables(File[] files)`
  Replace all installer variables and localization keys in a file array.
  `static String`
  `replaceVariables(String value)`
  Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `ReplacementMode.PLAIN` as the replacement mode and `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
  `static String[]`
  `replaceVariables(String[] values)`
  Same as `replaceVariables(String[], VariableErrorHandlingDescriptor)`, with `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
  `static String[]`
  `replaceVariables(String[] values, VariableErrorHandlingDescriptor errorHandlingDescriptor)`
  Replace all installer variables and localization keys in a string array.
  `static String`
  `replaceVariables(String value, ReplacementMode replacementMode)`
  Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
  `static String`
  `replaceVariables(String value, ReplacementMode replacementMode, VariableErrorHandlingDescriptor errorHandlingDescriptor)`
  Replace all installer variables and localization keys in a string.
  `static String`
  `replaceVariables(String value, VariableErrorHandlingDescriptor errorHandlingDescriptor)`
  Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `ReplacementMode.PLAIN` as the replacement mode.
  `static <T> T`
  `replaceWithTextOverride(Bean bean, String propertyName, T defaultValue, Class resultType)`
  A convenience method for `getTextOverrideValue(com.install4j.api.beans.Bean, java.lang.String, java.lang.Class<T>)` that returns a default value if no replacement has been configured.
  `protected boolean`
  `replaceWithTextOverride(String propertyName, boolean defaultValue)`
  `protected byte`
  `replaceWithTextOverride(String propertyName, byte defaultValue)`
  `protected char`
  `replaceWithTextOverride(String propertyName, char defaultValue)`
  `protected double`
  `replaceWithTextOverride(String propertyName, double defaultValue)`
  `protected float`
  `replaceWithTextOverride(String propertyName, float defaultValue)`
  `protected int`
  `replaceWithTextOverride(String propertyName, int defaultValue)`
  `protected long`
  `replaceWithTextOverride(String propertyName, long defaultValue)`
  `protected short`
  `replaceWithTextOverride(String propertyName, short defaultValue)`
  `protected <T> T`
  `replaceWithTextOverride(String propertyName, T defaultValue, Class resultType)`
  `static void`
  `rollbackActionList(ActionList actionList)`
  Roll back an action list.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### AbstractBean

    public AbstractBean()

- ## Method Details

  - ### replaceVariables

    public static String replaceVariables(String value) throws UndefinedVariableException
    Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `ReplacementMode.PLAIN` as the replacement mode and `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
    Parameters:
      `value` - the original string
    Returns:
      the string with all variables replaced.
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static String replaceVariables(String value, ReplacementMode replacementMode) throws UndefinedVariableException
    Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
    Parameters:
      `value` - the original string
      `replacementMode` - the replacement mode
    Returns:
      the string with all variables replaced.
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static String replaceVariables(String value, VariableErrorHandlingDescriptor errorHandlingDescriptor) throws UndefinedVariableException
    Same as `replaceVariables(String, ReplacementMode, VariableErrorHandlingDescriptor)`, with `ReplacementMode.PLAIN` as the replacement mode.
    Parameters:
      `value` - the original string
      `errorHandlingDescriptor` - describes how missing variables should be treated for each variable type
    Returns:
      the string with all variables replaced.
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static String replaceVariables(String value, ReplacementMode replacementMode, VariableErrorHandlingDescriptor errorHandlingDescriptor) throws UndefinedVariableException
    Replace all installer variables and localization keys in a string.

    Note: compiler variables in the project are replaced at compile time. Compiler variables in external files, such as a custom localization file, are not replaced at a compile time.

    Parameters:
      `value` - the original string
      `replacementMode` - the replacement mode
      `errorHandlingDescriptor` - describes how missing variables should be treated for each variable type
    Returns:
      the string with all variables replaced.
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static File replaceVariables(File file) throws UndefinedVariableException
    Replace all installer variables and localization keys in a file name. The used error handling descriptor is `VariableErrorHandlingDescriptor.DEFAULT`.

    Note: compiler variables in the project are replaced at compile time. Compiler variables in external files, such as a custom localization file, are not replaced at a compile time.

    Parameters:
      `file` - the original file
    Returns:
      the file with all variables replaced in its name.
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static String[] replaceVariables(String[] values) throws UndefinedVariableException
    Same as `replaceVariables(String[], VariableErrorHandlingDescriptor)`, with `VariableErrorHandlingDescriptor.DEFAULT` as the error handling descriptor.
    Parameters:
      `values` - the original array
    Returns:
      the array with all variables replaced
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static String[] replaceVariables(String[] values, VariableErrorHandlingDescriptor errorHandlingDescriptor) throws UndefinedVariableException
    Replace all installer variables and localization keys in a string array. For array elements that consist of an installer variable that in turn contains an array or a collection value, the elements of that array or collection value will be inserted into the returned array. For this reason, the returned array may have more elements than the original array. For example, if the array passed in as an argument has the elements:

           [0] = "One"
           [1] = "${installer:myVariable}"
           [2] = "Three"

    and the variable `myVariable` has a String array value with the elements

           [0] = "Blue"
           [1] = "Green"

    then the returned array will be

           [0] = "One"
           [1] = "Blue"
           [2] = "Green"
           [3] = "Three"

    If the array in an installer variable is not of type `String[]` or the collection is not of type `List<String>`, each element will be converted to a string by calling `toString()` on it.

    Note: compiler variables are replaced at compile time.

    Parameters:
      `values` - the original array
      `errorHandlingDescriptor` - describes how missing variables should be treated for each variable type
    Returns:
      the array with all variables replaced
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### replaceVariables

    public static File[] replaceVariables(File[] files) throws UndefinedVariableException
    Replace all installer variables and localization keys in a file array. This method is analogous to `replaceVariables(String[])`.
    Parameters:
      `files` - the original array
    Returns:
      the array with all variables replaced
    Throws:
      `UndefinedVariableException` - if a variable name cannot be found and the error handling is set to `VariableErrorHandling.EXCEPTION` for the variable type.

  - ### executeActionListSync

    public static boolean executeActionListSync(ActionList actionList, Object... extraScriptParameters) throws UserCanceledException
    Synchronously execute an action list. You should not use this method from a form component because it will block the EDT. Use `executeActionListAsync(ActionList, Object...)` instead.
    Parameters:
      `actionList` - the action list object from your bean property.
      `extraScriptParameters` - if the action list provides extra script parameters in the BeanInfo by calling `ActionListPropertyDescriptor.setExtraScriptParameters(ScriptParameter[])`, you have to pass them here.
    Returns:
      whether the list of actions was terminated due to an error. This can only happen if the user selected the "Break if an error occurs" check box in the configuration dialog of the action list, meaning that the `ActionList.isBreakOnError()` of the argument returns `true`. To detect errors in absence of this flag, call `Context.setErrorOccurred(boolean)` with an argument of `false` before calling this method and check the result of `Context.isErrorOccurred()` afterwards.
    Throws:
      `UserCanceledException`

  - ### executeActionListAsync

    public static void executeActionListAsync(ActionList actionList, Object... extraScriptParameters)
    Asynchronously execute an action list. Do not invoke this method from an action, it will throw an `IllegalStateException` in that case. For actions, use `executeActionListSync(ActionList, Object...)` instead. This method is intended to be used form a form component and will disable all components on the current screen while the action list is being executed.
    Parameters:
      `actionList` - the action list object from your bean property.
      `extraScriptParameters` - if the action list provides extra script parameters in the BeanInfo by calling `ActionListPropertyDescriptor.setExtraScriptParameters(ScriptParameter[])`, you have to pass them here.

  - ### rollbackActionList

    public static void rollbackActionList(ActionList actionList)
    Roll back an action list. This will only have an effect if called from the `InstallAction.rollback(InstallerContext)` method and if you called `executeActionListSync(ActionList, Object...)` before
    Parameters:
      `actionList` - the action list object from your bean property

  - ### getTextOverrideValue

    public static <T> T getTextOverrideValue(Bean bean, String propertyName, Class<T> resultType)
    Get the value for a property for which a text replacement has been configured in the IDE.

    For properties with non-String values of certain types, you can choose to switch to text entry mode in the context menu. This mechanism has to be enabled by calling `Install4JPropertyDescriptor.setAllowTextOverride(boolean)` with `true` in the property descriptor.

    The user can set the text value to an installer variable expression or to a compiler variable expression. In the getter of the property, the `replaceWithTextOverride()` method with the appropriate return type has to be called to perform the actual replacement. All these instance methods call this static method, so the feature also works for classes that do not extend `AbstractBean`.

    Parameters:
      `bean` - the bean for which the replacement should be performed
      `propertyName` - the property whose value should be replaced
      `resultType` - the type of the property
    Returns:
      the replaced value or null if no replacement has been configured

  - ### replaceWithTextOverride

    public static <T> T replaceWithTextOverride(Bean bean, String propertyName, T defaultValue, Class resultType)
    A convenience method for `getTextOverrideValue(com.install4j.api.beans.Bean, java.lang.String, java.lang.Class<T>)` that returns a default value if no replacement has been configured.

  - ### replaceWithTextOverride

    protected <T> T replaceWithTextOverride(String propertyName, T defaultValue, Class resultType)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected boolean replaceWithTextOverride(String propertyName, boolean defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected int replaceWithTextOverride(String propertyName, int defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected long replaceWithTextOverride(String propertyName, long defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected short replaceWithTextOverride(String propertyName, short defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected byte replaceWithTextOverride(String propertyName, byte defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected char replaceWithTextOverride(String propertyName, char defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected float replaceWithTextOverride(String propertyName, float defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`

  - ### replaceWithTextOverride

    protected double replaceWithTextOverride(String propertyName, double defaultValue)
    See Also:
      - `replaceWithTextOverride(Bean, String, Object, Class)`